package cn.com.ty.lift.ud.coupon.controller.query;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import cn.com.ty.lift.ud.common.BasePageQuery;
import cn.com.ty.lift.ud.coupon.mapper.entity.Coupon;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 卡券 查询条件
 * 
 * @author Xson
 * @date 2020-05-08
 */
@Data
@ApiModel(description = "卡券 查询条件")
public final class CouponQuery extends BasePageQuery {

    /**
     * 类型 1:折扣卷2:红包
     */
    @ApiModelProperty("类型 1:折扣卷2:红包")
    private Integer type;

    /**
     * 使用范围 1:出诊问诊2:题库3:视频
     */
    @ApiModelProperty("使用范围 1:出诊问诊2:题库3:视频")
    private Integer scenario;

    /**
     * 状态 0:正常1:不再前台显示
     */
    @ApiModelProperty("状态 1:正常0:不显示")
    private Integer statuz;

    /**
     * 审核状态 1:通过0:驳回2:待审核
     */
    @ApiModelProperty("审核状态 1:通过0:驳回2:待审核")
    private Integer checkFalg;

    /**
     * 查询条件
     * 
     * @return
     */
    @Override
    public Wrapper condition() {
        LambdaQueryWrapper<Coupon> query = new LambdaQueryWrapper<>();
        if (null != scenario) {
            query.eq(Coupon::getScenario, scenario);
        }
        if (null != type) {
            query.eq(Coupon::getType, type);
        }
        if (null != checkFalg) {
            query.eq(Coupon::getCheckFalg, checkFalg);
        }
        if (null != statuz) {
            query.eq(Coupon::getStatuz, statuz);
        }
        if (null != getSort()) {
            if (getSort().getOrder().indexOf("asc") != -1 || getSort().getOrder().indexOf("ASC") != -1) {
                query.orderByAsc(Coupon::getCreateTime);
            } else {
                query.orderByDesc(Coupon::getCreateTime);
            }
        }
        return query;
    }

    /**
     * 分页条件
     * 
     * @return
     */
    @Override
    public IPage page() {
        Page<Coupon> page = new Page<>(getPageNum(), getPageSize());
        return page;
    }

}
